// Generated by rstantools.  Do not edit by hand.

/*
    sccomp is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    sccomp is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with sccomp.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#include <rstan/rstaninc.hpp>
// Code generated by Stan version 2.21.0
#include <stan/model/model_header.hpp>
namespace model_glm_multi_beta_binomial_generate_date_namespace {
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;
static int current_statement_begin__;
stan::io::program_reader prog_reader__() {
    stan::io::program_reader reader;
    reader.add_event(0, 0, "start", "model_glm_multi_beta_binomial_generate_date");
    reader.add_event(47, 45, "end", "model_glm_multi_beta_binomial_generate_date");
    return reader;
}
#include <stan_meta_header.hpp>
class model_glm_multi_beta_binomial_generate_date
  : public stan::model::model_base_crtp<model_glm_multi_beta_binomial_generate_date> {
private:
        int N;
        int M;
        int C;
        int A;
        std::vector<int> exposure;
        matrix_d X;
        int is_truncated;
        double truncation_ajustment;
public:
    model_glm_multi_beta_binomial_generate_date(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, 0, pstream__);
    }
    model_glm_multi_beta_binomial_generate_date(stan::io::var_context& context__,
        unsigned int random_seed__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, random_seed__, pstream__);
    }
    void ctor_body(stan::io::var_context& context__,
                   unsigned int random_seed__,
                   std::ostream* pstream__) {
        typedef double local_scalar_t__;
        boost::ecuyer1988 base_rng__ =
          stan::services::util::create_rng(random_seed__, 0);
        (void) base_rng__;  // suppress unused var warning
        current_statement_begin__ = -1;
        static const char* function__ = "model_glm_multi_beta_binomial_generate_date_namespace::model_glm_multi_beta_binomial_generate_date";
        (void) function__;  // dummy to suppress unused var warning
        size_t pos__;
        (void) pos__;  // dummy to suppress unused var warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        try {
            // initialize data block variables from context__
            current_statement_begin__ = 2;
            context__.validate_dims("data initialization", "N", "int", context__.to_vec());
            N = int(0);
            vals_i__ = context__.vals_i("N");
            pos__ = 0;
            N = vals_i__[pos__++];
            current_statement_begin__ = 3;
            context__.validate_dims("data initialization", "M", "int", context__.to_vec());
            M = int(0);
            vals_i__ = context__.vals_i("M");
            pos__ = 0;
            M = vals_i__[pos__++];
            current_statement_begin__ = 4;
            context__.validate_dims("data initialization", "C", "int", context__.to_vec());
            C = int(0);
            vals_i__ = context__.vals_i("C");
            pos__ = 0;
            C = vals_i__[pos__++];
            current_statement_begin__ = 5;
            context__.validate_dims("data initialization", "A", "int", context__.to_vec());
            A = int(0);
            vals_i__ = context__.vals_i("A");
            pos__ = 0;
            A = vals_i__[pos__++];
            current_statement_begin__ = 6;
            validate_non_negative_index("exposure", "N", N);
            context__.validate_dims("data initialization", "exposure", "int", context__.to_vec(N));
            exposure = std::vector<int>(N, int(0));
            vals_i__ = context__.vals_i("exposure");
            pos__ = 0;
            size_t exposure_k_0_max__ = N;
            for (size_t k_0__ = 0; k_0__ < exposure_k_0_max__; ++k_0__) {
                exposure[k_0__] = vals_i__[pos__++];
            }
            current_statement_begin__ = 7;
            validate_non_negative_index("X", "N", N);
            validate_non_negative_index("X", "C", C);
            context__.validate_dims("data initialization", "X", "matrix_d", context__.to_vec(N,C));
            X = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, C);
            vals_r__ = context__.vals_r("X");
            pos__ = 0;
            size_t X_j_2_max__ = C;
            size_t X_j_1_max__ = N;
            for (size_t j_2__ = 0; j_2__ < X_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < X_j_1_max__; ++j_1__) {
                    X(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 9;
            context__.validate_dims("data initialization", "is_truncated", "int", context__.to_vec());
            is_truncated = int(0);
            vals_i__ = context__.vals_i("is_truncated");
            pos__ = 0;
            is_truncated = vals_i__[pos__++];
            current_statement_begin__ = 10;
            context__.validate_dims("data initialization", "truncation_ajustment", "double", context__.to_vec());
            truncation_ajustment = double(0);
            vals_r__ = context__.vals_r("truncation_ajustment");
            pos__ = 0;
            truncation_ajustment = vals_r__[pos__++];
            check_greater_or_equal(function__, "truncation_ajustment", truncation_ajustment, 1);
            // initialize transformed data variables
            // execute transformed data statements
            // validate transformed data
            // validate, set parameter ranges
            num_params_r__ = 0U;
            param_ranges_i__.clear();
            current_statement_begin__ = 15;
            validate_non_negative_index("beta", "C", C);
            validate_non_negative_index("beta", "M", M);
            num_params_r__ += (C * M);
            current_statement_begin__ = 16;
            validate_non_negative_index("alpha", "A", A);
            validate_non_negative_index("alpha", "M", M);
            num_params_r__ += (A * M);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    ~model_glm_multi_beta_binomial_generate_date() { }
    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        typedef double local_scalar_t__;
        stan::io::writer<double> writer__(params_r__, params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;
        current_statement_begin__ = 15;
        if (!(context__.contains_r("beta")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable beta missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("beta");
        pos__ = 0U;
        validate_non_negative_index("beta", "C", C);
        validate_non_negative_index("beta", "M", M);
        context__.validate_dims("parameter initialization", "beta", "matrix_d", context__.to_vec(C,M));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta(C, M);
        size_t beta_j_2_max__ = M;
        size_t beta_j_1_max__ = C;
        for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                beta(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(beta);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable beta: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 16;
        if (!(context__.contains_r("alpha")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable alpha missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("alpha");
        pos__ = 0U;
        validate_non_negative_index("alpha", "A", A);
        validate_non_negative_index("alpha", "M", M);
        context__.validate_dims("parameter initialization", "alpha", "matrix_d", context__.to_vec(A,M));
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> alpha(A, M);
        size_t alpha_j_2_max__ = M;
        size_t alpha_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                alpha(j_1__, j_2__) = vals_r__[pos__++];
            }
        }
        try {
            writer__.matrix_unconstrain(alpha);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable alpha: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }
    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }
    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(std::vector<T__>& params_r__,
                 std::vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {
        typedef T__ local_scalar_t__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // dummy to suppress unused var warning
        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;
        try {
            stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
            // model parameters
            current_statement_begin__ = 15;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> beta;
            (void) beta;  // dummy to suppress unused var warning
            if (jacobian__)
                beta = in__.matrix_constrain(C, M, lp__);
            else
                beta = in__.matrix_constrain(C, M);
            current_statement_begin__ = 16;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> alpha;
            (void) alpha;  // dummy to suppress unused var warning
            if (jacobian__)
                alpha = in__.matrix_constrain(A, M, lp__);
            else
                alpha = in__.matrix_constrain(A, M);
            // model body
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
        lp_accum__.add(lp__);
        return lp_accum__.sum();
    } // log_prob()
    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }
    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("beta");
        names__.push_back("alpha");
        names__.push_back("counts_uncorrected");
        names__.push_back("counts");
        names__.push_back("generated_exposure");
        names__.push_back("mu");
        names__.push_back("precision");
    }
    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dims__.push_back(C);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(A);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(N);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(N);
        dims__.push_back(M);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(N);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(M);
        dims__.push_back(N);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(M);
        dims__.push_back(N);
        dimss__.push_back(dims__);
    }
    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        typedef double local_scalar_t__;
        vars__.resize(0);
        stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
        static const char* function__ = "model_glm_multi_beta_binomial_generate_date_namespace::write_array";
        (void) function__;  // dummy to suppress unused var warning
        // read-transform, write parameters
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> beta = in__.matrix_constrain(C, M);
        size_t beta_j_2_max__ = M;
        size_t beta_j_1_max__ = C;
        for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                vars__.push_back(beta(j_1__, j_2__));
            }
        }
        Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> alpha = in__.matrix_constrain(A, M);
        size_t alpha_j_2_max__ = M;
        size_t alpha_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                vars__.push_back(alpha(j_1__, j_2__));
            }
        }
        double lp__ = 0.0;
        (void) lp__;  // dummy to suppress unused var warning
        stan::math::accumulator<double> lp_accum__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        if (!include_tparams__ && !include_gqs__) return;
        try {
            if (!include_gqs__ && !include_tparams__) return;
            if (!include_gqs__) return;
            // declare and define generated quantities
            current_statement_begin__ = 21;
            validate_non_negative_index("counts_uncorrected", "N", N);
            validate_non_negative_index("counts_uncorrected", "M", M);
            std::vector<std::vector<int> > counts_uncorrected(N, std::vector<int>(M, int(0)));
            stan::math::fill(counts_uncorrected, std::numeric_limits<int>::min());
            current_statement_begin__ = 24;
            validate_non_negative_index("counts", "N", N);
            validate_non_negative_index("counts", "M", M);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> counts(N, M);
            stan::math::initialize(counts, DUMMY_VAR__);
            stan::math::fill(counts, DUMMY_VAR__);
            current_statement_begin__ = 27;
            validate_non_negative_index("generated_exposure", "N", N);
            std::vector<double> generated_exposure(N, double(0));
            stan::math::initialize(generated_exposure, DUMMY_VAR__);
            stan::math::fill(generated_exposure, DUMMY_VAR__);
            current_statement_begin__ = 29;
            validate_non_negative_index("mu", "M", M);
            validate_non_negative_index("mu", "N", N);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> mu(M, N);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            stan::math::assign(mu,transpose(multiply(X, beta)));
            current_statement_begin__ = 30;
            validate_non_negative_index("precision", "M", M);
            validate_non_negative_index("precision", "N", N);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> precision(M, N);
            stan::math::initialize(precision, DUMMY_VAR__);
            stan::math::fill(precision, DUMMY_VAR__);
            stan::math::assign(precision,divide(transpose(multiply(stan::model::rvalue(X, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_min_max(1, A), stan::model::nil_index_list())), "X"), alpha)), (is_truncated ? stan::math::promote_scalar<double>(truncation_ajustment) : stan::math::promote_scalar<double>(1) )));
            // generated quantities statements
            current_statement_begin__ = 32;
            for (int i = 1; i <= N; ++i) {
                current_statement_begin__ = 32;
                stan::model::assign(mu, 
                            stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), 
                            stan::model::deep_copy(softmax(stan::model::rvalue(mu, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), "mu"))), 
                            "assigning variable mu");
            }
            current_statement_begin__ = 33;
            for (int i = 1; i <= N; ++i) {
                current_statement_begin__ = 34;
                stan::model::assign(counts_uncorrected, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::cons_list(stan::model::index_omni(), stan::model::nil_index_list())), 
                            beta_binomial_rng(get_base1(exposure, i, "exposure", 1), elt_multiply(stan::model::rvalue(mu, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), "mu"), stan::math::exp(stan::model::rvalue(precision, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), "precision"))), elt_multiply(subtract(1.0, stan::model::rvalue(mu, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), "mu")), stan::math::exp(stan::model::rvalue(precision, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(i), stan::model::nil_index_list())), "precision"))), base_rng__), 
                            "assigning variable counts_uncorrected");
            }
            current_statement_begin__ = 42;
            for (int n = 1; n <= N; ++n) {
                current_statement_begin__ = 42;
                stan::model::assign(generated_exposure, 
                            stan::model::cons_list(stan::model::index_uni(n), stan::model::nil_index_list()), 
                            sum(get_base1(counts_uncorrected, n, "counts_uncorrected", 1)), 
                            "assigning variable generated_exposure");
            }
            current_statement_begin__ = 43;
            for (int n = 1; n <= N; ++n) {
                current_statement_begin__ = 43;
                stan::model::assign(counts, 
                            stan::model::cons_list(stan::model::index_uni(n), stan::model::nil_index_list()), 
                            multiply(divide(to_row_vector(get_base1(counts_uncorrected, n, "counts_uncorrected", 1)), get_base1(generated_exposure, n, "generated_exposure", 1)), get_base1(exposure, n, "exposure", 1)), 
                            "assigning variable counts");
            }
            // validate, write generated quantities
            current_statement_begin__ = 21;
            size_t counts_uncorrected_k_0_max__ = N;
            size_t counts_uncorrected_k_1_max__ = M;
            for (size_t k_1__ = 0; k_1__ < counts_uncorrected_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < counts_uncorrected_k_0_max__; ++k_0__) {
                    vars__.push_back(counts_uncorrected[k_0__][k_1__]);
                }
            }
            current_statement_begin__ = 24;
            size_t counts_j_2_max__ = M;
            size_t counts_j_1_max__ = N;
            for (size_t j_2__ = 0; j_2__ < counts_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < counts_j_1_max__; ++j_1__) {
                    vars__.push_back(counts(j_1__, j_2__));
                }
            }
            current_statement_begin__ = 27;
            size_t generated_exposure_k_0_max__ = N;
            for (size_t k_0__ = 0; k_0__ < generated_exposure_k_0_max__; ++k_0__) {
                vars__.push_back(generated_exposure[k_0__]);
            }
            current_statement_begin__ = 29;
            size_t mu_j_2_max__ = N;
            size_t mu_j_1_max__ = M;
            for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                    vars__.push_back(mu(j_1__, j_2__));
                }
            }
            current_statement_begin__ = 30;
            size_t precision_j_2_max__ = N;
            size_t precision_j_1_max__ = M;
            for (size_t j_2__ = 0; j_2__ < precision_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < precision_j_1_max__; ++j_1__) {
                    vars__.push_back(precision(j_1__, j_2__));
                }
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng, params_r_vec, params_i_vec, vars_vec, include_tparams, include_gqs, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }
    std::string model_name() const {
        return "model_glm_multi_beta_binomial_generate_date";
    }
    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t beta_j_2_max__ = M;
        size_t beta_j_1_max__ = C;
        for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "beta" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t alpha_j_2_max__ = M;
        size_t alpha_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "alpha" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
        }
        if (!include_gqs__) return;
        size_t counts_uncorrected_k_0_max__ = N;
        size_t counts_uncorrected_k_1_max__ = M;
        for (size_t k_1__ = 0; k_1__ < counts_uncorrected_k_1_max__; ++k_1__) {
            for (size_t k_0__ = 0; k_0__ < counts_uncorrected_k_0_max__; ++k_0__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "counts_uncorrected" << '.' << k_0__ + 1 << '.' << k_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t counts_j_2_max__ = M;
        size_t counts_j_1_max__ = N;
        for (size_t j_2__ = 0; j_2__ < counts_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < counts_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "counts" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t generated_exposure_k_0_max__ = N;
        for (size_t k_0__ = 0; k_0__ < generated_exposure_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "generated_exposure" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t mu_j_2_max__ = N;
        size_t mu_j_1_max__ = M;
        for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "mu" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t precision_j_2_max__ = N;
        size_t precision_j_1_max__ = M;
        for (size_t j_2__ = 0; j_2__ < precision_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < precision_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "precision" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
    }
    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t beta_j_2_max__ = M;
        size_t beta_j_1_max__ = C;
        for (size_t j_2__ = 0; j_2__ < beta_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "beta" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t alpha_j_2_max__ = M;
        size_t alpha_j_1_max__ = A;
        for (size_t j_2__ = 0; j_2__ < alpha_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < alpha_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "alpha" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
        }
        if (!include_gqs__) return;
        size_t counts_uncorrected_k_0_max__ = N;
        size_t counts_uncorrected_k_1_max__ = M;
        for (size_t k_1__ = 0; k_1__ < counts_uncorrected_k_1_max__; ++k_1__) {
            for (size_t k_0__ = 0; k_0__ < counts_uncorrected_k_0_max__; ++k_0__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "counts_uncorrected" << '.' << k_0__ + 1 << '.' << k_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t counts_j_2_max__ = M;
        size_t counts_j_1_max__ = N;
        for (size_t j_2__ = 0; j_2__ < counts_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < counts_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "counts" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t generated_exposure_k_0_max__ = N;
        for (size_t k_0__ = 0; k_0__ < generated_exposure_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "generated_exposure" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t mu_j_2_max__ = N;
        size_t mu_j_1_max__ = M;
        for (size_t j_2__ = 0; j_2__ < mu_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "mu" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        size_t precision_j_2_max__ = N;
        size_t precision_j_1_max__ = M;
        for (size_t j_2__ = 0; j_2__ < precision_j_2_max__; ++j_2__) {
            for (size_t j_1__ = 0; j_1__ < precision_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "precision" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
    }
}; // model
}  // namespace
typedef model_glm_multi_beta_binomial_generate_date_namespace::model_glm_multi_beta_binomial_generate_date stan_model;
#ifndef USING_R
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
#endif
#endif
